## ros-melodic-robot-localization 2.6.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(robot_localization)

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message("${PROJECT_NAME}: You did not request a specific build type: selecting 'RelWithDebInfo'.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

find_package(catkin REQUIRED COMPONENTS
  diagnostic_msgs
  diagnostic_updater
  eigen_conversions
  geographic_msgs
  geometry_msgs
  message_filters
  message_generation
  nav_msgs
  nodelet
  roscpp
  roslint
  sensor_msgs
  std_msgs
  std_srvs
  tf2
  tf2_geometry_msgs
  tf2_ros
  xmlrpcpp)

find_package(PkgConfig REQUIRED)
pkg_check_modules(YAML_CPP yaml-cpp)

# Attempt to find Eigen using its own CMake module.
# If that fails, fall back to cmake_modules package.
find_package(Eigen3)
set(EIGEN_PACKAGE EIGEN3)
if(NOT EIGEN3_FOUND)
  find_package(cmake_modules REQUIRED)
  find_package(Eigen REQUIRED)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS})
  set(EIGEN3_LIBRARIES ${EIGEN_LIBRARIES})
  set(EIGEN_PACKAGE Eigen)
endif()

set(CMAKE_CXX_STANDARD 14)

if(NOT MSVC)
  set_directory_properties(PROPERTIES COMPILE_OPTIONS "-Wall;-Werror")
endif()
add_definitions(-DEIGEN_NO_DEBUG -DEIGEN_MPL2_ONLY)

set(ROSLINT_CPP_OPTS "--filter=-build/c++11,-runtime/references")
roslint_cpp()

###################################
## catkin specific configuration ##
###################################
add_service_files(
  FILES
    GetState.srv
    SetDatum.srv
    SetPose.srv
    ToggleFilterProcessing.srv
    FromLL.srv
    ToLL.srv
)

generate_messages(
  DEPENDENCIES
    geographic_msgs
    geometry_msgs
    std_msgs
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES 
    ekf
    ekf_localization_nodelet
    filter_base
    filter_utilities
    navsat_transform
    navsat_transform_nodelet
    ros_filter
    ros_filter_utilities
    robot_localization_estimator
    ros_robot_localization_listener
    ukf
    ukf_localization_nodelet
  CATKIN_DEPENDS
    cmake_modules
    diagnostic_msgs
    diagnostic_updater
    eigen_conversions
    geographic_msgs
    geometry_msgs
    message_filters
    message_runtime
    nav_msgs
    roscpp
    sensor_msgs
    std_msgs
    std_srvs
    tf2
    tf2_geometry_msgs
    tf2_ros
    xmlrpcpp
  DEPENDS
    ${EIGEN_PACKAGE}
    YAML_CPP
)

###########
## Build ##
###########

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
  ${EIGEN3_INCLUDE_DIRS}
  ${YAML_CPP_INCLUDE_DIRS})

link_directories(${YAML_CPP_LIBRARY_DIRS})

# Library definitions
add_library(filter_utilities src/filter_utilities.cpp)
add_library(filter_base src/filter_base.cpp)
add_library(ekf src/ekf.cpp)
add_library(ukf src/ukf.cpp)
add_library(robot_localization_estimator src/robot_localization_estimator.cpp)
add_library(ros_robot_localization_listener src/ros_robot_localization_listener.cpp)
add_library(ros_filter_utilities src/ros_filter_utilities.cpp)
add_library(ros_filter src/ros_filter.cpp)
add_library(navsat_transform src/navsat_transform.cpp)
add_library(ekf_localization_nodelet src/ekf_localization_nodelet.cpp)
add_library(ukf_localization_nodelet src/ukf_localization_nodelet.cpp)
add_library(navsat_transform_nodelet src/navsat_transform_nodelet.cpp)

# Executables
add_executable(ekf_localization_node src/ekf_localization_node.cpp)
add_executable(ukf_localization_node src/ukf_localization_node.cpp)
add_executable(navsat_transform_node src/navsat_transform_node.cpp)
add_executable(robot_localization_listener_node src/robot_localization_listener_node.cpp)

# Dependencies
add_dependencies(filter_base ${PROJECT_NAME}_gencpp)
add_dependencies(navsat_transform ${PROJECT_NAME}_gencpp)
add_dependencies(robot_localization_listener_node ${PROJECT_NAME}_gencpp)

# Linking
target_link_libraries(ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(filter_base filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ekf filter_base ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ukf filter_base ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ros_filter ekf ukf ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(robot_localization_estimator filter_utilities filter_base ekf ukf ${EIGEN3_LIBRARIES})
target_link_libraries(ros_robot_localization_listener robot_localization_estimator ros_filter_utilities
  ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES} ${YAML_CPP_LIBRARIES})
target_link_libraries(robot_localization_listener_node ros_robot_localization_listener ${catkin_LIBRARIES})
target_link_libraries(ekf_localization_node ros_filter ${catkin_LIBRARIES})
target_link_libraries(ekf_localization_nodelet ros_filter ${catkin_LIBRARIES})
target_link_libraries(ukf_localization_node ros_filter ${catkin_LIBRARIES})
target_link_libraries(ukf_localization_nodelet ros_filter ${catkin_LIBRARIES})
target_link_libraries(navsat_transform filter_utilities ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(navsat_transform_node navsat_transform ${catkin_LIBRARIES})
target_link_libraries(navsat_transform_nodelet navsat_transform ${catkin_LIBRARIES})

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS
  ekf
  ekf_localization_nodelet
  filter_base
  filter_utilities
  navsat_transform
  navsat_transform_nodelet
  ros_filter
  ros_filter_utilities
  robot_localization_estimator
  ros_robot_localization_listener
  ukf
  ukf_localization_nodelet
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

install(TARGETS
  ekf_localization_node
  navsat_transform_node
  robot_localization_listener_node
  ukf_localization_node
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE)

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  FILES_MATCHING PATTERN "*.launch")

install(DIRECTORY params/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/params)

install(FILES
  LICENSE
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)
install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

if (CATKIN_ENABLE_TESTING)

  roslint_add_test()

  # Not really necessary, but it will cause the build to fail if it's
  # missing, rather than failing once the tests are being executed
  find_package(rosbag REQUIRED)
  find_package(rostest REQUIRED)

  #### FILTER BASE TESTS ####
  catkin_add_gtest(filter_base-test test/test_filter_base.cpp)
  target_link_libraries(filter_base-test filter_base ${catkin_LIBRARIES})

  # This test uses ekf_localization node for convenience.
  add_rostest_gtest(test_filter_base_diagnostics_timestamps
                    test/test_filter_base_diagnostics_timestamps.test
                    test/test_filter_base_diagnostics_timestamps.cpp)
  target_link_libraries(test_filter_base_diagnostics_timestamps ${catkin_LIBRARIES} ${rostest_LIBRARIES})
  add_dependencies(test_filter_base_diagnostics_timestamps ekf_localization_node)

  #### EKF TESTS #####
  add_rostest_gtest(test_ekf
                    test/test_ekf.test
                    test/test_ekf.cpp)
  target_link_libraries(test_ekf ros_filter ekf ${catkin_LIBRARIES} ${rostest_LIBRARIES})


  add_rostest_gtest(test_ekf_localization_node_interfaces
                    test/test_ekf_localization_node_interfaces.test
                    test/test_ekf_localization_node_interfaces.cpp)
  target_link_libraries(test_ekf_localization_node_interfaces ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_node_bag1
                    test/test_ekf_localization_node_bag1.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_node_bag1 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_node_bag2
                    test/test_ekf_localization_node_bag2.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_node_bag2 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_node_bag3
                    test/test_ekf_localization_node_bag3.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_node_bag3 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_nodelet_bag1
                    test/test_ekf_localization_nodelet_bag1.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_nodelet_bag1 ${catkin_LIBRARIES} ${rostest_LIBRARIES})


  #### UKF TESTS #####
  add_rostest_gtest(test_ukf
                    test/test_ukf.test
                    test/test_ukf.cpp)
  target_link_libraries(test_ukf ros_filter ukf ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_interfaces
                    test/test_ukf_localization_node_interfaces.test
                    test/test_ukf_localization_node_interfaces.cpp)
  target_link_libraries(test_ukf_localization_node_interfaces ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_bag1
                    test/test_ukf_localization_node_bag1.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_node_bag1 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_bag2
                    test/test_ukf_localization_node_bag2.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_node_bag2 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_bag3
                    test/test_ukf_localization_node_bag3.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_node_bag3 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_nodelet_bag1
                    test/test_ukf_localization_nodelet_bag1.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_nodelet_bag1 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  #### RLE/RLL TESTS #####
  add_rostest_gtest(test_robot_localization_estimator
                    test/test_robot_localization_estimator.test
                    test/test_robot_localization_estimator.cpp)
  target_link_libraries(test_robot_localization_estimator
                        robot_localization_estimator
                        ${catkin_LIBRARIES}
                        ${rostest_LIBRARIES})

  add_executable(test_ros_robot_localization_listener_publisher test/test_ros_robot_localization_listener_publisher.cpp)
  target_link_libraries(test_ros_robot_localization_listener_publisher
                        ${catkin_LIBRARIES})

  add_rostest_gtest(test_ros_robot_localization_listener
                    test/test_ros_robot_localization_listener.test
                    test/test_ros_robot_localization_listener.cpp)
  target_link_libraries(test_ros_robot_localization_listener
                        ros_robot_localization_listener
                        ${catkin_LIBRARIES}
                        ${rostest_LIBRARIES})

endif()

=== debian/changelog ===
ros-melodic-robot-localization (2.6.7-1stretch) stretch; urgency=high

  * Parameterizing transform failure warnings
  * [melodic] Fix Windows build break. (#557 <https://github.com/cra-ros-pkg/robot_localization/issues/557>)
  * Contributors: Sean Yen, Tom Moore, florianspy

 -- Tom Moore <ayrton04@gmail.com>  Sun, 31 May 2020 23:00:00 -0000

ros-melodic-robot-localization (2.6.5-1stretch) stretch; urgency=high

  * fix: wall time used when use_sim_time is true
  * Created service for converting to / from lat long
  * Fix bug with tf_prefix
  * Adding new contribution to doc
  * Add missing undocumented params
  * Update wiki location
  * Contributors: Andrew Grindstaff, Axel Mousset, Charles Brian Quinn, Oswin So, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Wed, 07 Aug 2019 23:00:00 -0000

ros-melodic-robot-localization (2.6.4-1stretch) stretch; urgency=high

  * Meridian convergence adjustment added to navsat_transform.
  * Documentation changes
  * Add broadcast_utm_transform_as_parent_frame
  * Enable build optimisations if no build type configured.
  * Contributors: G.A. vd. Hoorn, Pavlo Kolomiiets, diasdm

 -- Tom Moore <ayrton04@gmail.com>  Fri, 15 Feb 2019 00:00:00 -0000

ros-melodic-robot-localization (2.6.3-1stretch) stretch; urgency=high

  * Rename odomBaseLinkTrans to baseLinkOdomTrans
    Adhere to the naming convention <fromFrame><toFrame>Trans used for worldBaseLinkTrans and mapOdomTrans.
  * Add const& to catch values to prevent the error:  catching polymorphic type ‘class tf2::TransformException’ by value
    And ZoneNumber by 0x3fU to prevent error: directive output may be truncated writing between 1 and 11 bytes into a region of size 4
  * Enabling the user to override the output child_frame_id
  * Fixing Euler body-to-world transformations
  * Whitespace
  * fixing no datum service in melodic
  * Contributors: Alexis schad, Matthew Jones, Tom Moore, thallerod

 -- Tom Moore <ayrton04@gmail.com>  Mon, 14 Jan 2019 00:00:00 -0000

ros-melodic-robot-localization (2.6.2-1stretch) stretch; urgency=high

  * Fixing tests
  * Contributors: Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Wed, 24 Oct 2018 23:00:00 -0000

ros-melodic-robot-localization (2.6.1-1stretch) stretch; urgency=high

  * Adding more output for measurement history failures
  * Adding filter processing toggle service
  * Waiting for valid ROS time before starting navsat_transform_node
  * Contributors: Tom Moore, stevemacenski

 -- Tom Moore <ayrton04@gmail.com>  Wed, 24 Oct 2018 23:00:00 -0000

ros-melodic-robot-localization (2.6.0-1stretch) stretch; urgency=high

  * Moving to C++14, adding error flags, and fixing all warnings
  * Contributors: Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Thu, 26 Jul 2018 23:00:00 -0000

ros-melodic-robot-localization (2.5.2-1stretch) stretch; urgency=high

  * Add published accel topic to documentation
  * adding log statements for nans in the invertable matrix
  * Fixing issue with potential seg fault
  * Contributors: Oleg Kalachev, Tom Moore, stevemacenski

 -- Tom Moore <ayrton04@gmail.com>  Tue, 10 Apr 2018 23:00:00 -0000

ros-melodic-robot-localization (2.5.1-1stretch) stretch; urgency=high

  * Fixing CMakeLists
  * Contributors: Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Wed, 03 Jan 2018 00:00:00 -0000

ros-melodic-robot-localization (2.5.0-1stretch) stretch; urgency=high

  * Fixing datum precision
  * Fixing timing variable
  * Fixing state history reversion
  * Fixing critical bug with dynamic process noise covariance
  * Fix typo in reading Mahalanobis thresholds.
  * Zero out rotation in GPS to base_link transform
  * Update xmlrpcpp includes for Indigo support
  * Removing lastUpdateTime
  * Fixing timestamps in map->odom transform
  * Simplify enabledAtStartup logic
  * Add std_srvs dependency
  * Add enabling service
  * Ensure all raw sensor input orientations are normalized even if messages are not
  * Install params directory.
  * Add robot localization estimator
  * Adding nodelet support
  * Contributors: Jacob Perron, Jacob Seibert, Jiri Hubacek, Mike Purvis, Miquel Massot, Pavlo Kolomiiets, Rein Appeldoorn, Rokus Ottervanger, Simon Gene Gottlieb, Tom Moore, stevemacenski

 -- Tom Moore <ayrton04@gmail.com>  Fri, 15 Dec 2017 00:00:00 -0000

ros-melodic-robot-localization (2.4.0-1stretch) stretch; urgency=high

  * Updated documentation
  * Added reset_on_time_jump option
  * Added feature to optionally publish utm frame as parent in navsat_transform_node
  * Moved global callback queue reset
  * Added initial_state parameter and documentation
  * Fixed ac/deceleration gains default logic
  * Added gravity parameter
  * Added delay and throttle if tf lookup fails
  * Fixed UKF IMUTwistBasicIO test
  * Added transform_timeout parameter
  * Set gps_odom timestamp before tf2 lookuptransform
  * Removed non-portable sincos calls
  * Simplified logic to account for correlated error
  * Added dynamic process noise covariance calculation
  * Fixed catkin_package Eigen warning
  * Added optional publication of acceleration state
  * Contributors: Brian Gerkey, Enrique Fernandez, Jochen Sprickerhof, Rein Appeldoorn, Simon Gene Gottlieb, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Sun, 11 Jun 2017 23:00:00 -0000

ros-melodic-robot-localization (2.3.1-1stretch) stretch; urgency=high

  * Adding gitignore
  * Adding remaining wiki pages
  * Adding config and prep pages
  * Adding navsat_transform_node documentation
  * use_odometry_yaw fix for n_t_n
  * Fixing issue with manual pose reset when history is not empty
  * Getting inverse transform when looking up robot's pose.
  * Sphinx documentation
  * Removing forward slashes from navsat_transform input topics for template launch file
  * Adding example launch and parameter files for a two-level EKF setup with navsat_transform_node
  * Adding yaml file for navsat_transform_node, and moving parameter documentation to it.
  * Updating EKF and UKF parameter templates with usage comments


=== debian/control ===
Source: ros-melodic-robot-localization
Section: misc
Priority: optional
Maintainer: Tom Moore <ayrton04@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libyaml-cpp-dev, python-catkin-pkg, ros-melodic-catkin, ros-melodic-cmake-modules, ros-melodic-diagnostic-msgs, ros-melodic-diagnostic-updater, ros-melodic-eigen-conversions, ros-melodic-geographic-msgs, ros-melodic-geometry-msgs, ros-melodic-message-filters, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-nodelet, ros-melodic-rosbag, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest, ros-melodic-rosunit, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-xmlrpcpp
Homepage: http://ros.org/wiki/robot_localization
Standards-Version: 3.9.2

Package: ros-melodic-robot-localization
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libyaml-cpp-dev, ros-melodic-cmake-modules, ros-melodic-diagnostic-msgs, ros-melodic-diagnostic-updater, ros-melodic-eigen-conversions, ros-melodic-geographic-msgs, ros-melodic-geometry-msgs, ros-melodic-message-filters, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-xmlrpcpp
Description: Provides nonlinear state estimation through sensor fusion of an abritrary number of sensors.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG -O3

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-robot-localization//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-robot-localization 2.6.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.3)
+cmake_minimum_required(VERSION 3.0.2)
 project(robot_localization)
 
 if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
@@ -23,11 +23,15 @@
   std_srvs
   tf2
   tf2_geometry_msgs
-  tf2_ros
-  xmlrpcpp)
+  tf2_ros)
 
 find_package(PkgConfig REQUIRED)
 pkg_check_modules(YAML_CPP yaml-cpp)
+
+
+# Geographiclib installs FindGeographicLib.cmake to this non-standard location
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "/usr/share/cmake/geographiclib/")
+find_package(GeographicLib REQUIRED)
 
 # Attempt to find Eigen using its own CMake module.
 # If that fails, fall back to cmake_modules package.
@@ -59,6 +63,7 @@
     GetState.srv
     SetDatum.srv
     SetPose.srv
+    SetUTMZone.srv
     ToggleFilterProcessing.srv
     FromLL.srv
     ToLL.srv
@@ -104,9 +109,9 @@
     tf2
     tf2_geometry_msgs
     tf2_ros
-    xmlrpcpp
   DEPENDS
     ${EIGEN_PACKAGE}
+    GeographicLib
     YAML_CPP
 )
 
@@ -162,9 +167,9 @@
 target_link_libraries(ekf_localization_nodelet ros_filter ${catkin_LIBRARIES})
 target_link_libraries(ukf_localization_node ros_filter ${catkin_LIBRARIES})
 target_link_libraries(ukf_localization_nodelet ros_filter ${catkin_LIBRARIES})
-target_link_libraries(navsat_transform filter_utilities ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
-target_link_libraries(navsat_transform_node navsat_transform ${catkin_LIBRARIES})
-target_link_libraries(navsat_transform_nodelet navsat_transform ${catkin_LIBRARIES})
+target_link_libraries(navsat_transform filter_utilities ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES} ${GeographicLib_LIBRARIES})
+target_link_libraries(navsat_transform_node navsat_transform ${catkin_LIBRARIES} ${GeographicLib_LIBRARIES})
+target_link_libraries(navsat_transform_nodelet navsat_transform ${catkin_LIBRARIES} ${GeographicLib_LIBRARIES})
 
 #############
 ## Install ##
@@ -323,6 +328,3 @@
   target_link_libraries(test_ros_robot_localization_listener
                         ros_robot_localization_listener
                         ${catkin_LIBRARIES}
-                        ${rostest_LIBRARIES})
-
-endif()

=== debian/changelog ===
ros-melodic-robot-localization (2.6.12-1bionic) bionic; urgency=high

  * Moved GeographicLib from build_depend to depend (#689 <https://github.com/cra-ros-pkg/robot_localization/issues/689>)
  * Contributors: Joshua Owen

 -- Tom Moore <ayrton04@gmail.com>  Sun, 07 Aug 2022 23:00:00 -0000

ros-melodic-robot-localization (2.6.11-1bionic) bionic; urgency=high

  * Prevent node from crashing on invalid UTM zone, but throw ROS_ERROR to notify user (#683 <https://github.com/cra-ros-pkg/robot_localization/issues/683>)
  * Contributors: MCFurry

 -- Tom Moore <ayrton04@gmail.com>  Thu, 22 Jul 2021 23:00:00 -0000

ros-melodic-robot-localization (2.6.10-1bionic) bionic; urgency=high

  * Fixing navsat_transform linking
  * SHARED linking for Geographiclib (#624 <https://github.com/cra-ros-pkg/robot_localization/issues/624>)
  * Fixed a typo in validate filter output error message. (#646 <https://github.com/cra-ros-pkg/robot_localization/issues/646>)
  * Fix transformomation for gravitation vector to IMU frame before removing acceleration (#639 <https://github.com/cra-ros-pkg/robot_localization/issues/639>)
  * Stick to the global utm_zone_ when transforming gps to UTM (#627 <https://github.com/cra-ros-pkg/robot_localization/issues/627>)
  * UTM conversions using geographiclib (#626 <https://github.com/cra-ros-pkg/robot_localization/issues/626>)
  * Update state_estimation_nodes.rst (#623 <https://github.com/cra-ros-pkg/robot_localization/issues/623>)
  * Fixing lat-long to UTM conversion (#620 <https://github.com/cra-ros-pkg/robot_localization/issues/620>)
  * Removing xmlrpcpp dependency
  * Contributors: Achmad Fathoni, JJB_UT, Leonardo Hemerly, Paul Verhoeckx, Tim Clephas, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Thu, 03 Jun 2021 23:00:00 -0000

ros-melodic-robot-localization (2.6.9-1bionic) bionic; urgency=high

  * Fix warning "Failed to meet update rate!" (#602 <https://github.com/cra-ros-pkg/robot_localization/issues/602>)
  * Fix sign error in dFY_dP part of transferFunctionJacobian_ (#592 <https://github.com/cra-ros-pkg/robot_localization/issues/592>)
  * Fix typo in navsat_transform_node.rst (#588 <https://github.com/cra-ros-pkg/robot_localization/issues/588>)
  * fix issue caused by starting on uneven terrain (#582 <https://github.com/cra-ros-pkg/robot_localization/issues/582>)
  * Local Cartesian Option (#575 <https://github.com/cra-ros-pkg/robot_localization/issues/575>)
  * Fix frame id of imu in differential mode, closes #482 <https://github.com/cra-ros-pkg/robot_localization/issues/482>. (#522 <https://github.com/cra-ros-pkg/robot_localization/issues/522>)
  * navsat_transform diagram to address #550 <https://github.com/cra-ros-pkg/robot_localization/issues/550> (#570 <https://github.com/cra-ros-pkg/robot_localization/issues/570>)
  * Increasing the minimum CMake version (#573 <https://github.com/cra-ros-pkg/robot_localization/issues/573>)
  * Contributors: Aleksander Bojda, David Jensen, James Baxter, Jeffrey Kane Johnson, Mabel Zhang, Mike, Ronald Ensing, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Thu, 17 Dec 2020 00:00:00 -0000

ros-melodic-robot-localization (2.6.8-1bionic) bionic; urgency=high

  * Adding conditional build dependencies (#572 <https://github.com/cra-ros-pkg/robot_localization/issues/572>)
  * Contributors: Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Tue, 02 Jun 2020 23:00:00 -0000

ros-melodic-robot-localization (2.6.7-1bionic) bionic; urgency=high

  * Parameterizing transform failure warnings
  * [melodic] Fix Windows build break. (#557 <https://github.com/cra-ros-pkg/robot_localization/issues/557>)
  * Contributors: Sean Yen, Tom Moore, florianspy

 -- Tom Moore <ayrton04@gmail.com>  Sun, 31 May 2020 23:00:00 -0000

ros-melodic-robot-localization (2.6.5-1bionic) bionic; urgency=high

  * fix: wall time used when use_sim_time is true
  * Created service for converting to / from lat long
  * Fix bug with tf_prefix
  * Adding new contribution to doc
  * Add missing undocumented params
  * Update wiki location
  * Contributors: Andrew Grindstaff, Axel Mousset, Charles Brian Quinn, Oswin So, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Wed, 07 Aug 2019 23:00:00 -0000

ros-melodic-robot-localization (2.6.4-1bionic) bionic; urgency=high

  * Meridian convergence adjustment added to navsat_transform.
  * Documentation changes
  * Add broadcast_utm_transform_as_parent_frame
  * Enable build optimisations if no build type configured.
  * Contributors: G.A. vd. Hoorn, Pavlo Kolomiiets, diasdm

 -- Tom Moore <ayrton04@gmail.com>  Fri, 15 Feb 2019 00:00:00 -0000

ros-melodic-robot-localization (2.6.3-1bionic) bionic; urgency=high

  * Rename odomBaseLinkTrans to baseLinkOdomTrans
    Adhere to the naming convention <fromFrame><toFrame>Trans used for worldBaseLinkTrans and mapOdomTrans.
  * Add const& to catch values to prevent the error:  catching polymorphic type ‘class tf2::TransformException’ by value
    And ZoneNumber by 0x3fU to prevent error: directive output may be truncated writing between 1 and 11 bytes into a region of size 4
  * Enabling the user to override the output child_frame_id
  * Fixing Euler body-to-world transformations
  * Whitespace
  * fixing no datum service in melodic
  * Contributors: Alexis schad, Matthew Jones, Tom Moore, thallerod

 -- Tom Moore <ayrton04@gmail.com>  Mon, 14 Jan 2019 00:00:00 -0000

ros-melodic-robot-localization (2.6.2-1bionic) bionic; urgency=high

  * Fixing tests
  * Contributors: Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Wed, 24 Oct 2018 23:00:00 -0000

ros-melodic-robot-localization (2.6.1-1bionic) bionic; urgency=high

  * Adding more output for measurement history failures
  * Adding filter processing toggle service
  * Waiting for valid ROS time before starting navsat_transform_node
  * Contributors: Tom Moore, stevemacenski

 -- Tom Moore <ayrton04@gmail.com>  Wed, 24 Oct 2018 23:00:00 -0000

ros-melodic-robot-localization (2.6.0-1bionic) bionic; urgency=high



=== debian/control ===
Source: ros-melodic-robot-localization
Section: misc
Priority: optional
Maintainer: Tom Moore <ayrton04@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, libgeographic-dev, libyaml-cpp-dev, python-catkin-pkg, ros-melodic-catkin, ros-melodic-cmake-modules, ros-melodic-diagnostic-msgs, ros-melodic-diagnostic-updater, ros-melodic-eigen-conversions, ros-melodic-geographic-msgs, ros-melodic-geometry-msgs, ros-melodic-message-filters, ros-melodic-message-generation, ros-melodic-nav-msgs, ros-melodic-nodelet, ros-melodic-rosbag <!nocheck>, ros-melodic-roscpp, ros-melodic-roslint, ros-melodic-rostest <!nocheck>, ros-melodic-rosunit <!nocheck>, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros
Homepage: http://ros.org/wiki/robot_localization
Standards-Version: 3.9.2

Package: ros-melodic-robot-localization
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, libgeographic-dev, libyaml-cpp-dev, ros-melodic-cmake-modules, ros-melodic-diagnostic-msgs, ros-melodic-diagnostic-updater, ros-melodic-eigen-conversions, ros-melodic-geographic-msgs, ros-melodic-geometry-msgs, ros-melodic-message-filters, ros-melodic-message-runtime, ros-melodic-nav-msgs, ros-melodic-nodelet, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-std-msgs, ros-melodic-std-srvs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros
Description: Provides nonlinear state estimation through sensor fusion of an abritrary number of sensors.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG -O3
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"
+		-DCMAKE_PREFIX_PATH="/opt/ros/melodic" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
